var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _DynamicLinkAnalyticsParameters_native, _DynamicLinkAndroidParameters_native, _DynamicLinkIOSParameters_native, _DynamicLinkITunesParameters_native, _DynamicLinkNavigationParameters_native, _DynamicLinkSocialParameters_native, _DynamicLinkParameters_native, _DynamicLinkParameters_analytics, _DynamicLinkParameters_android, _DynamicLinkParameters_ios, _DynamicLinkParameters_itunes, _DynamicLinkParameters_navigation, _DynamicLinkParameters_social, _DynamicLink_native, _a, _DynamicLinks_native, _DynamicLinks_app, _DynamicLinks_appDelegateInitialized;
import { deserialize, firebase, FirebaseApp, FirebaseError } from '@nativescript/firebase-core';
import { ShortLinkType } from './common';
let defaultDynamicLinks;
const fb = firebase();
Object.defineProperty(fb, 'dynamicLinks', {
    value: () => {
        if (!defaultDynamicLinks) {
            defaultDynamicLinks = new DynamicLinks();
        }
        return defaultDynamicLinks;
    },
    writable: false,
});
let appDelegate;
let _launchOptions;
var AppDelegateImpl = /** @class */ (function (_super) {
    __extends(AppDelegateImpl, _super);
    function AppDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AppDelegateImpl_1 = AppDelegateImpl;
    Object.defineProperty(AppDelegateImpl, "sharedInstance", {
        get: function () {
            if (!appDelegate) {
                appDelegate = AppDelegateImpl_1.alloc().init();
            }
            return appDelegate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppDelegateImpl, "launchOptions", {
        get: function () {
            return _launchOptions;
        },
        enumerable: true,
        configurable: true
    });
    AppDelegateImpl.prototype.applicationOpenURLOptions = function (app, url, options) {
        return this.applicationOpenURLSourceApplicationAnnotation(app, url, options.objectForKey(UIApplicationOpenURLOptionsSourceApplicationKey), options.objectForKey(UIApplicationOpenURLOptionsAnnotationKey));
    };
    AppDelegateImpl.prototype.applicationOpenURLSourceApplicationAnnotation = function (application, url, sourceApplication, annotation) {
        var dynamicLink = FIRDynamicLinks.dynamicLinks().dynamicLinkFromCustomSchemeURL(url);
        if (!dynamicLink) {
            dynamicLink = FIRDynamicLinks.dynamicLinks().dynamicLinkFromUniversalLinkURL(url);
        }
        if (!dynamicLink) {
            return false;
        }
        if (dynamicLink.url) {
            if (typeof DynamicLinks._onLink === 'function') {
                DynamicLinks._onLink(DynamicLink.fromNative(dynamicLink));
            }
        }
        return false;
    };
    AppDelegateImpl.prototype.applicationContinueUserActivityRestorationHandler = function (application, userActivity, restorationHandler) {
        var retried = false;
        var callback = function (dynamicLink, error) {
            if (!error && (dynamicLink === null || dynamicLink === void 0 ? void 0 : dynamicLink.url)) {
                if (typeof DynamicLinks._onLink === 'function') {
                    DynamicLinks._onLink(DynamicLink.fromNative(dynamicLink));
                }
            }
            if (error && !retried && NSPOSIXErrorDomain === error.domain && error.code === 53) {
                retried = true;
                FIRDynamicLinks.dynamicLinks().handleUniversalLinkCompletion(userActivity.webpageURL, callback);
            }
            if (error) {
                console.error('Unknown error occurred when attempting to handle a universal link', error);
            }
        };
        FIRDynamicLinks.dynamicLinks().handleUniversalLinkCompletion(userActivity.webpageURL, callback);
        return false;
    };
    AppDelegateImpl.prototype.applicationDidFinishLaunchingWithOptions = function (application, launchOptions) {
        _launchOptions = launchOptions;
        return false;
    };
    var AppDelegateImpl_1;
    AppDelegateImpl = AppDelegateImpl_1 = __decorate([
        ObjCClass(UIApplicationDelegate)
    ], AppDelegateImpl);
    return AppDelegateImpl;
}(UIResponder));
export class DynamicLinkAnalyticsParameters {
    constructor() {
        _DynamicLinkAnalyticsParameters_native.set(this, void 0);
        __classPrivateFieldSet(this, _DynamicLinkAnalyticsParameters_native, FIRDynamicLinkGoogleAnalyticsParameters.parameters(), "f");
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkGoogleAnalyticsParameters) {
            const result = new DynamicLinkAnalyticsParameters();
            __classPrivateFieldSet(result, _DynamicLinkAnalyticsParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get campaign() {
        return this.native.campaign;
    }
    set campaign(value) {
        this.native.campaign = value;
    }
    get content() {
        return this.native.content;
    }
    set content(value) {
        this.native.content = value;
    }
    get medium() {
        return this.native.medium;
    }
    set medium(value) {
        this.native.medium = value;
    }
    get source() {
        return this.native.source;
    }
    set source(value) {
        this.native.source = value;
    }
    get term() {
        return this.native.term;
    }
    set term(value) {
        this.native.term = value;
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkAnalyticsParameters_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLinkAnalyticsParameters_native = new WeakMap();
export class DynamicLinkAndroidParameters {
    constructor(packageName) {
        _DynamicLinkAndroidParameters_native.set(this, void 0);
        __classPrivateFieldSet(this, _DynamicLinkAndroidParameters_native, FIRDynamicLinkAndroidParameters.parametersWithPackageName(packageName), "f");
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkAndroidParameters) {
            const result = new DynamicLinkAndroidParameters();
            __classPrivateFieldSet(result, _DynamicLinkAndroidParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get fallbackUrl() {
        var _b;
        return (_b = this.native.fallbackURL) === null || _b === void 0 ? void 0 : _b.absoluteString;
    }
    set fallbackUrl(value) {
        this.native.fallbackURL = NSURL.URLWithString(value);
    }
    get minimumVersion() {
        return this.native.minimumVersion;
    }
    set minimumVersion(value) {
        this.native.minimumVersion = value;
    }
    get packageName() {
        return this.native.packageName;
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkAndroidParameters_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLinkAndroidParameters_native = new WeakMap();
export class DynamicLinkIOSParameters {
    constructor(bundleId) {
        _DynamicLinkIOSParameters_native.set(this, void 0);
        const id = bundleId || NSBundle.mainBundle.bundleIdentifier;
        __classPrivateFieldSet(this, _DynamicLinkIOSParameters_native, FIRDynamicLinkIOSParameters.parametersWithBundleID(id), "f");
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkIOSParameters) {
            const result = new DynamicLinkIOSParameters();
            __classPrivateFieldSet(result, _DynamicLinkIOSParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get appStoreId() {
        return this.native.appStoreID;
    }
    set appStoreId(value) {
        this.native.appStoreID = value;
    }
    get bundleId() {
        return this.native.bundleID;
    }
    get customScheme() {
        return this.native.customScheme;
    }
    set customScheme(value) {
        this.native.customScheme = value;
    }
    get fallbackUrl() {
        var _b;
        return (_b = this.native.fallbackURL) === null || _b === void 0 ? void 0 : _b.absoluteString;
    }
    set fallbackUrl(value) {
        this.native.fallbackURL = NSURL.URLWithString(value);
    }
    get iPadBundleId() {
        return this.native.iPadBundleID;
    }
    set iPadBundleId(value) {
        this.native.iPadBundleID = value;
    }
    get iPadFallbackUrl() {
        var _b;
        return (_b = this.native.iPadFallbackURL) === null || _b === void 0 ? void 0 : _b.absoluteString;
    }
    set iPadFallbackUrl(value) {
        this.native.iPadFallbackURL = NSURL.URLWithString(value);
    }
    get minimumVersion() {
        return this.native.minimumAppVersion;
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkIOSParameters_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLinkIOSParameters_native = new WeakMap();
export class DynamicLinkITunesParameters {
    constructor() {
        _DynamicLinkITunesParameters_native.set(this, void 0);
        __classPrivateFieldSet(this, _DynamicLinkITunesParameters_native, FIRDynamicLinkItunesConnectAnalyticsParameters.parameters(), "f");
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkItunesConnectAnalyticsParameters) {
            const result = new DynamicLinkITunesParameters();
            __classPrivateFieldSet(result, _DynamicLinkITunesParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get affiliateToken() {
        return this.native.affiliateToken;
    }
    set affiliateToken(value) {
        this.native.affiliateToken = value;
    }
    get campaignToken() {
        return this.native.campaignToken;
    }
    set campaignToken(value) {
        this.native.campaignToken = value;
    }
    get providerToken() {
        return this.native.providerToken;
    }
    set providerToken(value) {
        this.native.providerToken = value;
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkITunesParameters_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLinkITunesParameters_native = new WeakMap();
export class DynamicLinkNavigationParameters {
    constructor() {
        _DynamicLinkNavigationParameters_native.set(this, void 0);
        __classPrivateFieldSet(this, _DynamicLinkNavigationParameters_native, FIRDynamicLinkNavigationInfoParameters.parameters(), "f");
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkNavigationInfoParameters) {
            const result = new DynamicLinkNavigationParameters();
            __classPrivateFieldSet(result, _DynamicLinkNavigationParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get forcedRedirectEnabled() {
        return this.native.forcedRedirectEnabled;
    }
    set forcedRedirectEnabled(value) {
        this.native.forcedRedirectEnabled = value;
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkNavigationParameters_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLinkNavigationParameters_native = new WeakMap();
export class DynamicLinkSocialParameters {
    constructor() {
        _DynamicLinkSocialParameters_native.set(this, void 0);
        __classPrivateFieldSet(this, _DynamicLinkSocialParameters_native, FIRDynamicLinkSocialMetaTagParameters.parameters(), "f");
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkSocialMetaTagParameters) {
            const result = new DynamicLinkSocialParameters();
            __classPrivateFieldSet(result, _DynamicLinkSocialParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get descriptionText() {
        return this.native.descriptionText;
    }
    set descriptionText(value) {
        this.native.descriptionText = value;
    }
    get imageUrl() {
        var _b;
        return (_b = this.native.imageURL) === null || _b === void 0 ? void 0 : _b.absoluteString;
    }
    set imageUrl(value) {
        this.native.imageURL = NSURL.URLWithString(value);
    }
    get title() {
        return this.native.title;
    }
    set title(value) {
        this.native.title = value;
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkSocialParameters_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLinkSocialParameters_native = new WeakMap();
export class DynamicLinkParameters {
    constructor() {
        _DynamicLinkParameters_native.set(this, void 0);
        _DynamicLinkParameters_analytics.set(this, void 0);
        _DynamicLinkParameters_android.set(this, void 0);
        _DynamicLinkParameters_ios.set(this, void 0);
        _DynamicLinkParameters_itunes.set(this, void 0);
        _DynamicLinkParameters_navigation.set(this, void 0);
        _DynamicLinkParameters_social.set(this, void 0);
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLinkComponents) {
            const result = new DynamicLinkParameters();
            __classPrivateFieldSet(result, _DynamicLinkParameters_native, link, "f");
            return result;
        }
        return null;
    }
    get analytics() {
        if (__classPrivateFieldGet(this, _DynamicLinkParameters_analytics, "f")) {
            return __classPrivateFieldGet(this, _DynamicLinkParameters_analytics, "f");
        }
        return DynamicLinkAnalyticsParameters.fromNative(this.native.analyticsParameters);
    }
    set analytics(value) {
        __classPrivateFieldSet(this, _DynamicLinkParameters_analytics, value, "f");
        this.native.analyticsParameters = value === null || value === void 0 ? void 0 : value.native;
    }
    get android() {
        if (__classPrivateFieldGet(this, _DynamicLinkParameters_android, "f")) {
            return __classPrivateFieldGet(this, _DynamicLinkParameters_android, "f");
        }
        return DynamicLinkAndroidParameters.fromNative(this.native.androidParameters);
    }
    set android(value) {
        __classPrivateFieldSet(this, _DynamicLinkParameters_android, value, "f");
        this.native.androidParameters = value === null || value === void 0 ? void 0 : value.native;
    }
    get domainUriPrefix() {
        return this.native.domain;
    }
    get ios() {
        if (__classPrivateFieldGet(this, _DynamicLinkParameters_ios, "f")) {
            return __classPrivateFieldGet(this, _DynamicLinkParameters_ios, "f");
        }
        return DynamicLinkIOSParameters.fromNative(this.native.iOSParameters);
    }
    set ios(value) {
        __classPrivateFieldSet(this, _DynamicLinkParameters_ios, value, "f");
        this.native.iOSParameters = value === null || value === void 0 ? void 0 : value.native;
    }
    get itunes() {
        if (__classPrivateFieldGet(this, _DynamicLinkParameters_itunes, "f")) {
            return __classPrivateFieldGet(this, _DynamicLinkParameters_itunes, "f");
        }
        return DynamicLinkITunesParameters.fromNative(this.native.iTunesConnectParameters);
    }
    get link() {
        var _b;
        return (_b = this.native.link) === null || _b === void 0 ? void 0 : _b.absoluteString;
    }
    get navigation() {
        if (__classPrivateFieldGet(this, _DynamicLinkParameters_navigation, "f")) {
            return __classPrivateFieldGet(this, _DynamicLinkParameters_navigation, "f");
        }
        return DynamicLinkNavigationParameters.fromNative(this.native.navigationInfoParameters);
    }
    set navigation(value) {
        __classPrivateFieldSet(this, _DynamicLinkParameters_navigation, value, "f");
        this.native.navigationInfoParameters = value === null || value === void 0 ? void 0 : value.native;
    }
    get social() {
        if (__classPrivateFieldGet(this, _DynamicLinkParameters_social, "f")) {
            return __classPrivateFieldGet(this, _DynamicLinkParameters_social, "f");
        }
        return DynamicLinkSocialParameters.fromNative(this.native.socialMetaTagParameters);
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinkParameters_native, "f");
    }
}
_DynamicLinkParameters_native = new WeakMap(), _DynamicLinkParameters_analytics = new WeakMap(), _DynamicLinkParameters_android = new WeakMap(), _DynamicLinkParameters_ios = new WeakMap(), _DynamicLinkParameters_itunes = new WeakMap(), _DynamicLinkParameters_navigation = new WeakMap(), _DynamicLinkParameters_social = new WeakMap();
export class DynamicLink {
    constructor() {
        _DynamicLink_native.set(this, void 0);
    }
    static fromNative(link) {
        if (link instanceof FIRDynamicLink) {
            const result = new DynamicLink();
            __classPrivateFieldSet(result, _DynamicLink_native, link, "f");
            return result;
        }
        return null;
    }
    get minimumAppVersion() {
        return this.native.minimumAppVersion;
    }
    get url() {
        var _b;
        return (_b = this.native.url) === null || _b === void 0 ? void 0 : _b.absoluteString;
    }
    get utmParameters() {
        return deserialize(this.native.utmParametersDictionary);
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLink_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_DynamicLink_native = new WeakMap();
export class DynamicLinks {
    constructor() {
        _DynamicLinks_native.set(this, void 0);
        _DynamicLinks_app.set(this, void 0);
        if (defaultDynamicLinks) {
            return defaultDynamicLinks;
        }
        defaultDynamicLinks = this;
        if (!__classPrivateFieldGet(DynamicLinks, _a, "f", _DynamicLinks_appDelegateInitialized)) {
            GULAppDelegateSwizzler.proxyOriginalDelegate();
            GULAppDelegateSwizzler.registerAppDelegateInterceptor(AppDelegateImpl.sharedInstance);
            __classPrivateFieldSet(DynamicLinks, _a, true, "f", _DynamicLinks_appDelegateInitialized);
        }
        __classPrivateFieldSet(this, _DynamicLinks_native, FIRDynamicLinks.dynamicLinks(), "f");
    }
    createLink(link, domainUriPrefix) {
        return DynamicLinkParameters.fromNative(FIRDynamicLinkComponents.alloc().initWithLinkDomainURIPrefix(NSURL.URLWithString(link), domainUriPrefix));
    }
    createShortLink(link, domainUriPrefix, shortLinkType = ShortLinkType.DEFAULT) {
        const nativeLink = FIRDynamicLinkComponents.alloc().initWithLinkDomainURIPrefix(NSURL.URLWithString(link), domainUriPrefix);
        const options = FIRDynamicLinkComponentsOptions.options();
        switch (shortLinkType) {
            case ShortLinkType.SHORT:
                options.pathLength = 1 /* Short */;
                break;
            case ShortLinkType.UNGUESSABLE:
                options.pathLength = 2 /* Unguessable */;
                break;
            default:
                options.pathLength = 0 /* Default */;
                break;
        }
        nativeLink.options = options;
        return DynamicLinkParameters.fromNative(nativeLink);
    }
    buildLink(link) {
        return new Promise((resolve, reject) => {
            resolve(link.native.url.absoluteString);
        });
    }
    onLink(listener) {
        DynamicLinks._onLink = listener;
    }
    resolveLink(link) {
        return new Promise((resolve, reject) => {
            this.native.handleUniversalLinkCompletion(NSURL.URLWithString(link), (dl, error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve(DynamicLink.fromNative(dl));
                }
            });
        });
    }
    get native() {
        return __classPrivateFieldGet(this, _DynamicLinks_native, "f");
    }
    get ios() {
        return this.native;
    }
    get app() {
        if (!__classPrivateFieldGet(this, _DynamicLinks_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _DynamicLinks_app, FirebaseApp.fromNative(FIRApp.defaultApp()), "f");
        }
        return __classPrivateFieldGet(this, _DynamicLinks_app, "f");
    }
}
_a = DynamicLinks, _DynamicLinks_native = new WeakMap(), _DynamicLinks_app = new WeakMap();
_DynamicLinks_appDelegateInitialized = { value: false };
//# sourceMappingURL=index.ios.js.map